package obu;

import java.util.Map;
import java.util.logging.Filter;
import java.util.logging.LogRecord;
import java.util.regex.Matcher;
import java.util.regex.Pattern;


public class ObuFilter implements Filter
{
    public boolean isLoggable(LogRecord record)
    {
        StackTraceElement[] stack = Thread.currentThread().getStackTrace();
        for(int i = 2; i < stack.length; i++)
        {
            if (stack[i].getClassName() == "obu.ObuFilter")
            {
                record.setMessage(record.getMessage() + " [ObuShutTheHellUp] Recursion detected. Please report this!");
                return true;
            }
        }

        if (record.getMessage() != null)
        {
            for(int i = 0; i < ShutTheHellUpPlugin.filterList.size(); i++)
            {
                try
                {
                    Map entry = ShutTheHellUpPlugin.filterList.get(i);
                    if (entry.get("level").toString().equalsIgnoreCase("ANY") || entry.get("level").toString().equalsIgnoreCase(record.getLevel().getName()))
                    {
                        if (entry.get("type").toString().equalsIgnoreCase("string") && record.getMessage().toLowerCase().contains(entry.get("value").toString().toLowerCase()))
                        {
                            return false;
                        }
                        if (entry.get("type").toString().equalsIgnoreCase("regex"))
                        {
                            Pattern pattern = Pattern.compile(entry.get("value").toString());
                            Matcher matcher = pattern.matcher(record.getMessage());
                            if (matcher.find())
                            {
                                return false;
                            }
                        }
                    }
                }
                catch(Exception ex)
                {
                    ShutTheHellUpPlugin.log.info("[" + ShutTheHellUpPlugin.pdfFile.getName() + " version " + ShutTheHellUpPlugin.pdfFile.getVersion() + "] Exception while trying to apply a filter");
                    ShutTheHellUpPlugin.log.info("[" + ShutTheHellUpPlugin.pdfFile.getName() + " version " + ShutTheHellUpPlugin.pdfFile.getVersion() + "] Exception Line (counting from 1): " + (i+1));
                    ShutTheHellUpPlugin.log.info("[" + ShutTheHellUpPlugin.pdfFile.getName() + " version " + ShutTheHellUpPlugin.pdfFile.getVersion() + "] Message: " + ex.getMessage());
                    ShutTheHellUpPlugin.log.info("[" + ShutTheHellUpPlugin.pdfFile.getName() + " version " + ShutTheHellUpPlugin.pdfFile.getVersion() + "] " + ex.toString());
                    ShutTheHellUpPlugin.log.info("[" + ShutTheHellUpPlugin.pdfFile.getName() + " version " +ShutTheHellUpPlugin. pdfFile.getVersion() + "] Controlled stack trace bellow:");
                    ex.printStackTrace();
                }
            }
        }
        
        if (ShutTheHellUpPlugin.oldFilter != null)
            return ShutTheHellUpPlugin.oldFilter.isLoggable(record);

        return true;
    }
}
